<?php

//////////////////////////////////////////////////////////////
//===========================================================
// premium.php
//===========================================================
// PAGELAYER
// Inspired by the DESIRE to be the BEST OF ALL
// ----------------------------------------------------------
// Started by: Pulkit Gupta
// Date:       23rd Jan 2017
// Time:       23:00 hrs
// Site:       http://pagelayer.com/wordpress (PAGELAYER)
// ----------------------------------------------------------
// Please Read the Terms of use at http://pagelayer.com/tos
// ----------------------------------------------------------
//===========================================================
// (c)Pagelayer Team
//===========================================================
//////////////////////////////////////////////////////////////

// Are we being accessed directly ?
if(!defined('PAGELAYER_VERSION')) {
	exit('Hacking Attempt !');
}



// Image Hotspot
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_image_hotspot', array(
		'name' => __pl('Image Hotspot'),
		'group' => 'image',
		'func' => 'pagelayer_sc_image_hotspot',
		'params' => array(
			'elements' => array(
				'type' => 'group',
				'sc' => PAGELAYER_SC_PREFIX.'_image_hotspot',
				'items' => array(
					'label' => array(
						'default' => __pl('hotspot'),
					),
					'count' => 0
				),
				'text' => __pl('Add New Hotspot'),
				'rules' => array(
						'rootSelector' => '.pagelayer-tooltip', // css selector of the internal object
						'activeSelector' => '.pagelayer-hotspot', // css selector of the active element
						'activeClass' => 'active' // css class name of the active element
						),
				'events' => array(
						'onActive' => array( // javascript event when item is activated
								'selector' => '.pagelayer-hotspot', // css selector of the element
								'event' => 'click' // event name
								),
						'onInactive' => array( // javascript event when item is de-activated
										'selector' => '.pagelayer-hotspot', // css selector of the element
										'event' => 'click' // event name
									)
						)
			),
			'img' => array(
				'type' => 'image',
				'label' => __pl('Main Image'),
				'default' => '',
				'desc' => __pl('Choose an image from Media Library'),
			),
			'common_hotspot_color' => array(
				'type' => 'color',
				'label' => __pl('Hotspot Theme'),
				'default' => 'mp-text-color-red',
				'list' => array(
					'mp-text-color-red' => __pl('red'),
					'mp-text-color-dark-grey' => __pl('grey'),
					'mp-text-color-black' => __pl('black'),
					'custom' => __pl('custom'),
				),
			),
			'common_hotspot_custom_color' => array(
				'type' => 'color',
				'label' => __pl('Hotspot Color'),
				'default' => '#e25441',
				'req' => array(
					'common_hotspot_color' => 'custom'
				)
			),
			'common_plus_color' => array(
				'type' => 'color',
				'label' => __pl('Hotspot Icon Color'),
				'default' => '#ffffff',
				'req' => array(
					'common_hotspot_color' => 'custom'
				)
			),
			'common_hotspot_size' => array(
				'type' => 'radio',
				'label' => __pl('Hotspot Size'),
				'default' => 'normal',
				'list' => array(
					'small' => __pl('small'),
					'normal' => __pl('middle'),
					'big' => __pl('large'),
				)
			),
			'common_tip_theme' => array(
				'type' => 'select',
				'label' => __pl('Tooltip Theme'),
				'default' => 'tooltipster-shadow',
				'list' => array(
					'tooltipster-default' => __pl('dark'),
					'tooltipster-light' => __pl('silver'),
					'tooltipster-noir' => __pl('noir'),
					'tooltipster-shadow' => __pl('shadow'),
					'tooltipster-dark' => __pl('black'),
					'custom' => __pl('custom'),
				),
			),
			'common_custom_bg_theme' => array(
				'type' => 'color',
				'label' => __pl('Tooltip Background Color'),
				'default' => '#eb002c',
				'req' => array(
					'common_tip_theme' => 'custom'
				)
			),
			'common_custom_font_theme' => array(
				'type' => 'color',
				'label' => __pl('Tooltip Font Color'),
				'default' => '#ffffff',
				'req' => array(
					'common_tip_theme' => 'custom'
				)
			),
			'common_tip_position' => array(
				'type' => 'select',
				'label' => 'Tooltip Position',
				'default' => 'top',
				'list' => array(
					'top' => __pl('top'),
					'right' => __pl('right'),
					'bottom' => __pl('bottom'),
					'left' => __pl('left'),
				)
			),
			'common_tip_show' => array(
				'type' => 'select',
				'label' => 'Display',
				'default' => 'hover',
				'list' => array(
					'hover' => __pl('On Hover'),
					'always' => __pl('always'),
					'click' => __pl('On Click'),
				)
			),
		)
	)
);




// Audio
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_audio', array(
		'name' => __pl('audio'),
		'group' => 'media',
		'func' => 'pagelayer_sc_audio',
		'html' => '<div class="pagelayer-audio-container">
			<audio controls>
				<source src="{{{src-url}}}"></source>
			</audio>
		</div>',
		'params' => array(
			'src' => array(
				'type' => 'audio',
				'label' => __pl('wp_audio_source_title'),
				'desc' => __pl('wp_audio_source_desc'),
				'default' => 'http://wpcom.files.wordpress.com/2007/01/mattmullenweg-interview.mp3',
			),
			'autoplay' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_audio_autoplay_title'),
				'desc' => __pl('wp_audio_autoplay_desc'),
				'default' => '',
				'addAttr' => ['{{element}} audio' => 'autoplay="autoplay"'],
			),
			'loop' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_audio_loop_title'),
				'desc' => __pl('wp_audio_loop_desc'),
				'default' => '',
				'addAttr' => ['{{element}} audio' => 'loop="loop"'],
			)
		)
	)
);


// Video Slider
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_video_slider', array(
		'name' => __pl('Video Slider'),
		'group' => 'media',
		'func' => 'pagelayer_sc_video_slider',
		'holder' => '.pagelayer-video-slider-holder',
		'html' => '<div class="pagelayer-video-slider-holder"></div>',
		'params' => array(
			'elements' => array(
				'type' => 'group',
				'label' => __pl('Videos'),
				'sc' => PAGELAYER_SC_PREFIX.'_video',
				'item_label' => array(
					'default' => __pl('video'),
					'param' => 'video_type'
				),
				'count' => 2,
				'text' => __pl('Add Media'),
			),
			'slideshow' => array(
				'type' => 'checkbox',
				'label' => __pl('Enable slideshow'),
				'desc' => '',
			),
			'autoplay' => array(
				'type' => 'checkbox',
				'label' => __pl('Autoplay slider'),
				'desc' => '',
				'default' => 'true',
				'req' => array(
					'slideshow' => 'true'
				)
			),
			'slideshow_speed' => array(
				'type' => 'spinner',
				'label' => __pl('Slideshow speed in seconds'),
				'default' => 800,
				'min' => 100,
				'max' => 10000,
				'step' => 100,
				'req' => array(
					'slideshow' => 'true'
				)
			),
			'slideshow_start' => array(
				'type' => 'spinner',
				'label' => __pl('Slideshow start with slide'),
				'default' => 1,
				'step' => 1,
			),
			'slider_transition' => array(
				'type' => 'select',
				'label' => __pl('Transition'),
				'desc' => '',
				'default' => 'fade',
				'list' => [
					'fade' => __pl('fade'),
					'horizontal' => __pl('horizontal'),
					'vertical' => __pl('vertical'),
					'kenburns' => __pl('kenburns'),
					'false' => __pl('none'),
				],
			),
			'slider_preload' => array(
				'type' => 'select',
				'label' => __pl('Preload slides'),
				'default' => 'visible',
				'list' => [
					'visible' => __pl('visible'),
					'all' => __pl('all'),
				],
			),
			'slider_pager' => array(
				'type' => 'checkbox',
				'label' => __pl('Pager'),
				'desc' => '',
				'default' => 'true',
			),
			'slider_loop' => array(
				'type' => 'checkbox',
				'label' => __pl('Slider loop'),
				'desc' => '',
				'default' => 'true',
			),
		)
	)
);

// Button Group
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_btn_grp', array(
		'name' => __pl('Button Group'),
		'group' => 'button',
		'func' => 'pagelayer_sc_btn_grp',
		'params' => array(
			'elements' => array(
				'type' => 'group',
				'label' => __pl('buttons'),
				'sc' => PAGELAYER_SC_PREFIX.'_btn',
				'item_label' => array(
					'default' => __pl('button'),
					'param' => 'text'
				),
				'count' => 2,
				'text' => strtr(__pl('add_new_item'), array('%name%' => __pl('button_name'))),
			),
			'align' => array(
				'type' => 'radio',
				'label' => __pl('obj_align_label'),
				'default' => 'left',
				'css' => 'text-align: {{val}}',
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right')
				)
			),
			'group_layout' => array(
				'type' => 'radio',
				'label' => __pl('layout'),
				'default' => 'pagelayer-btn-grp-horizontal',
				'css' => ['{{element}} .pagelayer-btn' => 'display: inline-block;'],
				'list' => array(
					'pagelayer-btn-grp-horizontal' => __pl('horizontal'),
					'' => __pl('vertical')
				)
			),
			'indent' => array(
				'type' => 'spinner',
				'label' => __pl('button_group_indent_label'),
				'default' => '5',
				'css' => ['{{element}} .pagelayer-btn' => 'padding-left: {{val}}px; padding-right: {{val}}px;'],
				'min' => 0,
				'step' => 1,
				'max' => 50,
				'default' => 3,
			)
		)
	)
);
// Download Button
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_download', array(
		'name' => __pl('Download Button'),
		'group' => 'button',
		'func' => 'pagelayer_sc_download',
		'html' => '<a href="{{{attachment-url}}}" target="_blank" class="pagelayer-btn-holder pagelayer-ele-link {{type}} {{size}} {{icon_position}}" download>
					<i class="fa fa-{{icon}} pagelayer-btn-icon"></i>
					<span class="pagelayer-btn-text">{{text}}</span>
					<i class="fa fa-{{icon}} pagelayer-btn-icon"></i>
				</a>',
		'params' => array(
			'attachment' => array(
				'type' => 'media',
				'label' => __pl('media_file'),
				'desc' => __pl('media_description'),
				'default' => '',
			),
			'text' => array(
				'type' => 'text',
				'label' => __pl('button_text_label'),
				'default' => 'Download'
			),
			'type' => array(
				'type' => 'select',
				'label' => __pl('button_type_label'),
				'default' => 'pagelayer-btn-default',
				'list' => array(
					'pagelayer-btn-default' => __pl('btn_type_default'),
					'pagelayer-btn-primary' => __pl('btn_type_primary'),
					'pagelayer-btn-secondary' => __pl('btn_type_secondary'),
					'pagelayer-btn-success' => __pl('btn_type_success'),
					'pagelayer-btn-info' => __pl('btn_type_info'),
					'pagelayer-btn-warning' => __pl('btn_type_warning'),
					'pagelayer-btn-danger' => __pl('btn_type_danger'),
					'pagelayer-btn-dark' => __pl('btn_type_dark'),
					'pagelayer-btn-light' => __pl('btn_type_light'),
					'pagelayer-btn-link' => __pl('btn_type_link')
				),
			),
			'size' => array(
				'type' => 'radio',
				'label' => __pl('button_size_label'),
				'default' => 'pagelayer-btn-large',
				'list' => array(
					'pagelayer-btn-mini' => __pl('mini'),
					'pagelayer-btn-small' => __pl('small'),
					'pagelayer-btn-large' => __pl('large'),
					'pagelayer-btn-extra-large' => __pl('extra_large'),
					'pagelayer-btn-double-large' => __pl('double_large'),
					'pagelayer-btn-custom' => __pl('custom'),
				)
			),
			'btn_custom_size' => array(
				'type' => 'spinner',
				'label' => __pl('btn_custom_size'),
				'min' => 1,
				'step' => 1,
				'max' => 100,
				'default' => 5,
				'css' => ['{{element}} .pagelayer-btn-holder' => 'padding: {{val}}px calc({{val}}px *2)'],
				'req' => array(
					'size' => 'pagelayer-btn-custom'
				),
			),
			'icon' => array(
				'type' => 'icon',
				'label' => __pl('service_box_font_icon_label'),
				'default' => 'download',
			),
			'icon_position' => array(
				'type' => 'radio',
				'label' => __pl('icon_alignment'),
				'default' => 'pagelayer-btn-icon-left',
				'list' => array(
					'pagelayer-btn-icon-left' => __pl('left'),
					'pagelayer-btn-icon-right' => __pl('right')
				),
				'req' => array(
					'!icon' => 'none'
				)
			),
			'icon_spacing' => array(
				'type' => 'spinner',
				'label' => __pl('icon_spacing'),
				'min' => 1,
				'step' => 1,
				'max' => 100,
				'default' => 5,
				'css' => ['{{element}} .pagelayer-btn-icon' => 'padding: 0 {{val}}px;'],
				'req' => array(
					'!icon' => 'none'
				),
			),
			'full_width' => array(
				'type' => 'checkbox',
				'label' => __pl('stretch'),
				'css' => ['{{element}} a' => 'width: 100%; text-align: center;']
			),
			'align' => array(
				'type' => 'radio',
				'label' => __pl('obj_align_label'),
				'default' => 'left',
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right')
				),
				'req' => array(
					'full_width' => ''
				)
			)
		)
	)
);

// Social Share Button
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_share', array(
		'name' => __pl('Share'),
		'group' => 'button',
		'not_visible' => 1,
		'func' => 'pagelayer_sc_share',
		'html' => '
				<a class="pagelayer-ele-link pagelayer-share-{{icon}}" title="{{icon}}" href="{{social_url}}" target="_blank">
					<div class="pagelayer-share-content pagelayer-{{icon}}-icon">
						<div class="pagelayer-icon-holder pagelayer-share-buttons">
							<i class="fa fa-{{icon}}"></i>
						</div>
						<div class="pagelayer-icon-name">
							<span>{{icon_label}}</span>
						</div>
					</div>
				</a>',
		'params' => array(
			'icon' => array(
				'type' => 'icon',
				'label' => __pl('list_icon_label'),
				'default' => 'facebook-official',
				'list' => ['facebook', 'facebook-official', 'facebook-square', 'twitter', 'twitter-square', 'google-plus', 'google-plus-square', 'instagram', 'linkedin', 'linkedin-square', 'pinterest', 'pinterest-p', 'pinterest-square', 'reddit-alien', 'reddit-square', 'reddit', 'skype', 'stumbleupon', 'telegram', 'tumblr', 'tumblr-square', 'vk', 'weibo', 'whatsapp', 'wordpress', 'xing', 'xing-square', 'delicious', 'dribbble'],
			),
			'text' => array(
				'type' => 'text',
				'label' => __pl('share_text_label')
			)
		)
	)
);

// Social Share Group
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_share_grp', array(
		'name' => __pl('Social Share'),
		'group' => 'button',
		'func' => 'pagelayer_sc_share_grp',
		'params' => array(
			'elements' => array(
				'type' => 'group',
				'label' => __pl('social_share_grp'),
				'sc' => PAGELAYER_SC_PREFIX.'_share',
				'item_label' => array(
					'default' => __pl('share_item'),
					'param' => 'text'
				),
				'count' => 3,
				'text' => strtr(__pl('add_new_item'), array('%name%' => __pl('share_name'))),
			),
			'icon_size' => array(
				'type' => 'spinner',
				'label' => __pl('social_grp_size_label'),
				'css' => ['{{element}} i' => 'font-size: {{val}}px;',
					'{{element}} .pagelayer-icon-holder' => 'font-size: {{val}}px;'],
				'min' => 1,
				'step' => 1,
				'max' => 500,
				'default' => 40,
			),
			'align' => array(
				'type' => 'radio',
				'label' => __pl('obj_align_label'),
				'default' => 'center',
				'css' => 'text-align: {{val}};',
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right')
				)
			),
			'bg_shape' => array(
				'type' => 'radio',
				'label' => __pl('icon_background_shape'),
				'default' => 'pagelayer-social-shape-square',
				//'css' => ['{{element}} .fa' => 'height:1em; width:1em; position: absolute; top: 50%; left: 50%; transform: translate(-50% , -50%);',
				//'{{element}} .pagelayer-icon-holder' => 'position: relative; min-height: 1em; min-width: 1em;'],
				'addClass' => '{{val}}',
				'list' => array(
					'pagelayer-social-bg-none' => __pl('icon_shape_none'),
					'pagelayer-social-shape-circle' => __pl('icon_shape_circle'),
					'pagelayer-social-shape-square' => __pl('icon_shape_square'),
					'pagelayer-social-shape-rounded' => __pl('icon_shape_rounded'),
					'pagelayer-social-outline-border' => __pl('icon_shape_outline')
				),
			),
			'bg_size' => array(
				'type' => 'spinner',
				'label' => __pl('social_grp_size_label'),
				'css' => ['{{element}} .pagelayer-icon-holder' => 'height: {{val}}em; width: {{val}}em;'],
				'min' => 1,
				'step' => 0.1,
				'max' => 5,
				'default' => 1.7,
				'req' => array(
					'!bg_shape' => ''
				)
			),
			'group_layout' => array(
				'type' => 'radio',
				'label' => __pl('layout'),
				'default' => 'pagelayer-btn-grp-horizontal',
				'css' => ['{{element}} .pagelayer-share' => 'display: inline-block;'],
				'list' => array(
					'' => __pl('vertical'),
					'pagelayer-btn-grp-horizontal' => __pl('horizontal')
				)
			),
			'show_name' => array(
				'type' => 'checkbox',
				'label' => __pl('share_icon_name_label'),
				'default' => 'true',
				'css' => ['{{element}} .pagelayer-icon-name span' => 'display: block;'],
			),
		)
	)
);

// Table
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_table', array(
		'name' => __pl('table'),
		'group' => 'other',
		'func' => 'pagelayer_sc_table',
		'params' => array(
			'table' => array(
				'type' => 'textarea',
				'label' => __pl('obj_table_data_label'),
				'default' => 'Year,Sales,Expenses<br />2004,1000,400<br />2005,1170,460<br />2006,660,1120<br />2007,1030,540',
				'desc' => __pl('obj_table_data_desc'),
			)
		)
	)
);

// Call To Action
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_call', array(
		'name' => __pl('Call To Action'),
		'group' => 'other',
		'func' => 'pagelayer_sc_call',
		'html' => '<span if={{show_ribbon}} class="pagelayer-cta-ribbon">{{ribbon_text}}</span>
				<div if="{{cta_image}}" class="pagelayer-cta-image" style="background-image:url({{{cta_image-url}}});">
				</div>
				<div class="pagelayer-cta-content-holder">
					<div class="pagelayer-cta-content">
						<div if="{{heading}}" class="pagelayer-cta-heading">{{heading}}</div>
						<div if="{{subheading}}" class="pagelayer-cta-subheading">{{subheading}}</div>
						<div if="{{content}}" class="pagelayer-cta-text">{{content}}</div>
						<a if={{button_text}} class="pagelayer-btn-holder pagelayer-ele-link {{btn_type}} {{btn_size}}" href="{{button_link}}">{{button_text}}</a>
					</div>
				</div>',
		'params' => array(
			'layout' => array(
				'type' => 'select',
				'label' => __pl('cta_layout_label'),
				'default' => 'classic',
				'addClass' => 'pagelayer-cta-layout-{{val}}',
				'list' => array(
					'normal' => __pl('Normal'),
					'overlay' => __pl('Overlay')
				)
			),
			'align' => array(
				'type' => 'radio',
				'label' => __pl('cta_align_label'),
				'default' => '',
				'screen' => 1,
				'addClass' => 'pagelayer-cta-align-{{val}}',
				'list' => array(
					'left' => __pl('left'),
					'' => __pl('center'),
					'right' => __pl('right'),
				),
				'req' => array(
					'layout' => 'normal'
				)
			),
			'cta_image' => array(
				'type' => 'image',
				'label' => __pl('cta_image_label'),
			),
			'height' => array(
				'type' => 'slider',
				'label' => __pl('cta_img_height_label'),
				'css' => ['{{element}} .pagelayer-cta-image' => 'min-height: {{val}}px;'],
				'default' => 300,
				'min' => 0,
				'max' => 1000,
				'step' => 1,
			),
			'width' => array(
				'type' => 'slider',
				'label' => __pl('cta_img_width_label'),
				'css' => ['{{element}} .pagelayer-cta-image' => 'flex-basis: {{val}}%;',
					'{{element}} .pagelayer-cta-content-holder' => 'flex-basis: calc(100% - {{val}}%);'],
				'default' => 50,
				'min' => 0,
				'max' => 100,
				'step' => 1,
				'req' => array(
					'layout' => 'normal',
					'!align' => ''
				)
			),
			'heading' => array(
				'type' => 'text',
				'label' => __pl('heading_name'),
				'default' => 'Lorem ipsum dolor',
				'edit' => '.pagelayer-cta-heading',
			),
			'heading_typo' => array(
				'type' => 'typography',
				'label' => __pl('heading_typo'),
				'css' => ['{{element}} .pagelayer-cta-heading' => 'font-size: {{val[0]}}px; font-style: {{val[1]}}; font-weight: {{val[2]}}; font-variant: {{val[3]}}; text-decoration-line: {{val[4]}}; text-decoration-style: {{val[5]}}; line-height: {{val[6]}}em; text-transform: {{val[7]}}; letter-spacing: {{val[8]}}px; word-spacing: {{val[9]}}px;'],
			),
			'heading_shadow' => array(
				'type' => 'shadow',
				'label' => __pl('heading_shadow'),
				'css' => ['{{element}} .pagelayer-cta-heading' => 'text-shadow: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}};'],
			),
			'subheading' => array(
				'type' => 'text',
				'label' => __pl('subheading_name'),
				'default' => 'Lorem ipsum dolor sit amet',
				'edit' => '.pagelayer-cta-subheading',
			),
			'content' => array(
				'type' => 'editor',
				'label' => __pl('text'),
				'default' => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor.',
				'edit' => '.pagelayer-cta-text',
			),
			'content_spacing' => array(
				'type' => 'slider',
				'label' => __pl('cta_content_spacing_label'),
				'css' => ['{{element}} .pagelayer-cta-content' => 'padding: {{val}}px;'],
				'default' => 15,
				'min' => 0,
				'max' => 100,
				'step' => 1
			),
			'content-align' => array(
				'type' => 'radio',
				'label' => __pl('cta_content_align_label'),
				'default' => 'center',
				'css' => ['{{element}} .pagelayer-cta-content-holder' => 'text-align: {{val}};'],
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right'),
				)
			),
			'content_valign' => array(
				'type' => 'radio',
				'label' => __pl('cta_valign_label'),
				'default' => 'center',
				'screen' => 1,
				'addClass' => 'pagelayer-cta-align-{{val}}',
				'css' => ['{{element}} .pagelayer-cta-content-holder' => 'align-items: {{val}};'],
				'list' => array(
					'flex-start' => __pl('top'),
					'center' => __pl('center'),
					'flex-end' => __pl('bottom'),
				),
				/* 'req' => array(
					'layout' => 'normal',
					'!align' => '',
				) */
			),
			'content_bg' => array(
				'type' => 'color',
				'label' => __pl('cta_content_bg_label'),
				'default' => '#eeeeee',
				'css' => ['{{element}} .pagelayer-cta-content-holder' => 'background-color: {{val}}'],
			),
			'heading_color' => array(
				'type' => 'color',
				'label' => __pl('cta_content_bg_label'),
				'default' => '#333333',
				'css' => ['{{element}} .pagelayer-cta-heading' => 'color: {{val}}'],
			),
			'subheading_color' => array(
				'type' => 'color',
				'label' => __pl('cta_content_bg_label'),
				'default' => '#555555',
				'css' => ['{{element}} .pagelayer-cta-subheading' => 'color: {{val}}'],
			),
			'content_color' => array(
				'type' => 'color',
				'label' => __pl('cta_content_bg_label'),
				'default' => '#999999',
				'css' => ['{{element}} .pagelayer-cta-text' => 'color: {{val}}'],
			),
			'button_text' => array(
				'type' => 'text',
				'label' => __pl('button_text_label'),
				'default' => __pl('button_name'),
			),
			'button_link' => array(
				'type' => 'link',
				'label' => __pl('ctaobj_button_link_label'),
				'desc' => __pl('button_link_desc'),
			),
			'btn_type' => array(
				'type' => 'select',
				'label' => __pl('button_type_label'),
				'default' => 'pagelayer-btn-default',
				'list' => array(
					'pagelayer-btn-default' => __pl('btn_type_default'),
					'pagelayer-btn-primary' => __pl('btn_type_primary'),
					'pagelayer-btn-secondary' => __pl('btn_type_secondary'),
					'pagelayer-btn-success' => __pl('btn_type_success'),
					'pagelayer-btn-info' => __pl('btn_type_info'),
					'pagelayer-btn-warning' => __pl('btn_type_warning'),
					'pagelayer-btn-danger' => __pl('btn_type_danger'),
					'pagelayer-btn-dark' => __pl('btn_type_dark'),
					'pagelayer-btn-light' => __pl('btn_type_light'),
					'pagelayer-btn-link' => __pl('btn_type_link')
				),
			),
			'btn_size' => array(
				'type' => 'radio',
				'label' => __pl('button_size_label'),
				'default' => 'pagelayer-btn-large',
				'list' => array(
					'pagelayer-btn-mini' => __pl('mini'),
					'pagelayer-btn-small' => __pl('small'),
					'pagelayer-btn-large' => __pl('large'),
					'pagelayer-btn-extra-large' => __pl('extra_large'),
					'pagelayer-btn-double-large' => __pl('double_large'),
					'pagelayer-btn-custom' => __pl('custom'),
				)
			),
			'btn_custom_size' => array(
				'type' => 'spinner',
				'label' => __pl('btn_custom_size'),
				'min' => 1,
				'step' => 1,
				'max' => 100,
				'default' => 5,
				'css' => ['{{element}} .pagelayer-btn-holder' => 'padding: {{val}}px {{val}}px;'],
				'req' => array(
					'btn_size' => 'pagelayer-btn-custom'
				),
			),
			'btn_spacing' => array(
				'type' => 'slider',
				'label' => __pl('cta_btn_spacing_label'),
				'css' => ['{{element}} .pagelayer-btn-holder' => 'margin-top: {{val}}px;'],
				'default' => 15,
				'min' => 0,
				'max' => 100,
				'step' => 1,
			),
			'hover_anim' => array(
				'type' => 'select',
				'label' => __pl('cta_hover_anim_label'),
				'default' => 'pagelayer-btn-default',
				'addClass' => '{{val}}',
				'list' => array(
					'' => __pl('cta_anim_none'),
					'pagelayer-cta-zoomin' => __pl('cta_anim_zoomin'),
					'pagelayer-cta-zoomout' => __pl('cta_anim_zoomout'),
					'pagelayer-cta-moveup' => __pl('cta_anim_moveup'),
					'pagelayer-cta-movedown' => __pl('cta_anim_movedown'),
					'pagelayer-cta-moveleft' => __pl('cta_anim_moveleft'),
					'pagelayer-cta-moveright' => __pl('cta_anim_moveright'),
				),
			),
			'show_ribbon' => array(
				'type' => 'checkbox',
				'label' => __pl('cta_show_ribbon'),
				'css' => ['{{element}} .pagelayer-cta-ribbon' => 'position: absolute; z-index: 2;'],
				'default' => 'false'
			),
			'ribbon_text' => array(
				'type' => 'text',
				'label' => __pl('cta_ribbon_text_label'),
				'default' => __pl('This is Ribbon!'),
				'req' => array(
					'show_ribbon' => 'true'
				),
			),
			'ribbon_bg' => array(
				'type' => 'color',
				'label' => __pl('cta_ribbon_bg_label'),
				'default' => '#999999',
				'css' => ['{{element}} .pagelayer-cta-ribbon' => 'background-color: {{val}}'],
				'req' => array(
					'show_ribbon' => 'true'
				),
			),
			'ribbon_color' => array(
				'type' => 'color',
				'label' => __pl('cta_ribbon_color_label'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-cta-ribbon' => 'color: {{val}}'],
				'req' => array(
					'show_ribbon' => 'true'
				),
			),
			'ribbon_spacing' => array(
				'type' => 'padding',
				'label' => __pl('cta_ribbon_spacing'),
				'css' => ['{{element}} .pagelayer-cta-ribbon' => 'padding: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;'],
				'req' => [
					'show_ribbon' => 'true'
				]
			),
			'ribbon_pos' => array(
				'type' => 'select',
				'label' => __pl('ribbon_pos_label'),
				'css' => ['{{element}} .pagelayer-cta-ribbon' => 'right: 0px;'],
				'default' => '',
				'list' => array(
					'' => __pl('Left'),
					'right' => __pl('Right')
				),
				'req' => [
					'show_ribbon' => 'true'
				]
			),
			'ribbon_top' => array(
				'type' => 'slider',
				'label' => __pl('cta_btn_spacing_label'),
				'css' => ['{{element}} .pagelayer-cta-ribbon' => 'top: {{val}}%;'],
				'default' => 3,
				'min' => 0,
				'max' => 100,
				'step' => 1,
				'req' => [
					'show_ribbon' => 'true',
				]
			),
			'ribbon_shadow' => array(
				'type' => 'shadow',
				'label' => __pl('heading_shadow'),
				'css' => ['{{element}} .pagelayer-cta-ribbon' => 'box-shadow: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}};'],
				'req' => [
					'show_ribbon' => 'true',
				]
			),     
		)
	)
);

// Modal
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_modal', array(
		'name' => __pl('modal'),
		'group' => 'other',
		'func' => 'pagelayer_sc_modal',
		'innerHTML' => 'content',
		'html' => '<div class="pagelayer-modal-container">
			<div class="pagelayer-modal-button">
				<a class="pagelayer-btn-holder pagelayer-ele-link {{type}} {{size}} {{button_icon_position}}" onclick="pagelayer_render_pl_modal(this)" if="{{button_text}}">
					<i class="fa fa-{{button_icon}} pagelayer-btn-icon pagelayer-icon-left"></i>
					<span class="pagelayer-btn-text">{{button_text}}</span>
					<i class="fa fa-{{button_icon}} pagelayer-btn-icon pagelayer-icon-right"></i>
				</a>
			</div>
			<div class="pagelayer-modal-content {{modal_style}}">
				<div class="pagelayer-modal-close" onclick="pagelayer_pl_modal_close(this)"></div>
				<div class="pagelayer-modal-body {{modal_popup_width}}">
					<div if="{{modal_title}}"class="pagelayer-modal-title">{{modal_title}}</div>
					<div class="pagelayer-modal-bottom-content" if-ext="{{content}}">{{content}}</div>
				</div>
			</div>
		</div>',
		'params' => array(
			'modal_title' => array(
				'type' => 'textarea',
				'label' => __pl('title'),
				'text' => __pl('modal_name') . ' ' . __pl('title'),
				'default' => __pl('modal_title_content_default'),
			),
			'title_align' => array(
				'type' => 'radio',
				'label' => __pl('title') . ' ' . __pl('obj_align_label'),
				'default' => 'left',
				'css' => ['{{element}} .pagelayer-modal-title' => 'text-align: {{val}}'],
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right')
				),
				'req' => [
					'!modal_title' => ''
				],
			),
			'padding' => array(
				'type' => 'padding',
				'label' => __pl('title') . ' ' . __pl('padding'),
				'default' => 'padding: 35px',
				'css' => ['{{element}} .pagelayer-modal-title' => 'padding-top: {{val[0]}}px; padding-right: {{val[1]}}px; padding-bottom: {{val[2]}}px; padding-left: {{val[3]}}px'],
				'req' => [
					'!modal_title' => ''
				],
			),
			'content' => array(
				'type' => 'editor',
				'label' => __pl('obj_content'),
				'text' => __pl('edit') . ' ' . __pl('modal_name'),
				'default' => __pl('content_with_tags_default'),
				'css' => ['{{element}} .pagelayer-modal-content' => 'display: none'],
			),
			'modal_popup_width' => array(
				'type' => 'slider',
				'label' => __pl('modal_popup_width'),
				'default' => 70,
				'min' => 20,
				'max' => 100,
				'step' => 10,
				'css' => ['{{element}} .pagelayer-modal-body' => 'width: {{val}}%'],
			),
			'button_text' => array(
				'type' => 'text',
				'label' => __pl('button_text_label'),
				'default' => 'Open Modal Box',
				'edit' => '.pagelayer-modal-bottom-content',
			),
			'type' => array(
				'type' => 'select',
				'label' => __pl('button_type_label'),
				'default' => 'pagelayer-btn-default',
				'list' => array(
					'pagelayer-btn-default' => __pl('btn_type_default'),
					'pagelayer-btn-primary' => __pl('btn_type_primary'),
					'pagelayer-btn-secondary' => __pl('btn_type_secondary'),
					'pagelayer-btn-success' => __pl('btn_type_success'),
					'pagelayer-btn-info' => __pl('btn_type_info'),
					'pagelayer-btn-warning' => __pl('btn_type_warning'),
					'pagelayer-btn-danger' => __pl('btn_type_danger'),
					'pagelayer-btn-dark' => __pl('btn_type_dark'),
					'pagelayer-btn-light' => __pl('btn_type_light'),
					'pagelayer-btn-link' => __pl('btn_type_link')
				),
			),
			'size' => array(
				'type' => 'radio',
				'label' => __pl('button_size_label'),
				'default' => 'pagelayer-btn-large',
				'list' => array(
					'pagelayer-btn-mini' => __pl('mini'),
					'pagelayer-btn-small' => __pl('small'),
					'pagelayer-btn-large' => __pl('large'),
					'pagelayer-btn-extra-large' => __pl('extra_large'),
					'pagelayer-btn-double-large' => __pl('double_large'),
					'pagelayer-btn-custom' => __pl('custom'),
				)
			),
			'btn_custom_size' => array(
				'type' => 'spinner',
				'label' => __pl('btn_custom_size'),
				'min' => 1,
				'step' => 1,
				'max' => 100,
				'default' => 5,
				'css' => ['{{element}} .pagelayer-btn-holder' => 'padding: {{val}}px {{val}}px;'],
				'req' => array(
					'size' => 'pagelayer-btn-custom'
				)
			),
			'button_text' => array(
				'type' => 'text',
				'label' => __pl('button_text_label'),
				'default' => 'Open Modal Box'
			),
			'button_full_width' => array(
				'type' => 'checkbox',
				'label' => __pl('stretch') . ' ' . __pl('button_name'),
				'css' => ['{{element}} a' => 'width: 100%; text-align: center;']
			),
			'button_align' => array(
				'type' => 'radio',
				'label' => __pl('button_name') . ' ' . __pl('obj_align_label'),
				'default' => 'left',
				'css' => ['{{element}} .pagelayer-modal-button' => 'text-align: {{val}}'],
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right')
				),
				'req' => array(
					'!button_full_width' => 'true'
				)
			),
			'button_icon' => array(
				'type' => 'icon',
				'label' => __pl('button_name') . ' ' . __pl('service_box_font_icon_label'),
				'default' => 'none',
				'list' => pagelayer_icon_class_list(true)
			),
			'icon_spacing' => array(
				'type' => 'spinner',
				'label' => __pl('icon_spacing'),
				'min' => 1,
				'step' => 1,
				'max' => 100,
				'default' => 5,
				'css' => ['{{element}} .pagelayer-btn-icon' => 'padding: 0 {{val}}px;'],
				'req' => array(
					'!button_icon' => 'none'
				),
			),
			'button_icon_position' => array(
				'type' => 'radio',
				'label' => __pl('icon_alignment'),
				'default' => 'pagelayer-btn-icon-left',
				'list' => array(
					'pagelayer-btn-icon-left' => __pl('left'),
					'pagelayer-btn-icon-right' => __pl('right')
				),
				'req' => array(
					'!button_icon' => 'none'
				),
			),
			/* 'show_animation' => array(
				'type' => 'select',
				'label' => __pl('obj_show_animation_label'),
				'default' => '',
				'list' => array(
					'' => 'None',
					'bounce' => 'Bounce',
					'pulse' => 'Pulse',
					'rubberBand' => 'Rubber Band',
					'shake' => 'Shake',
					'swing' => 'Swing',
					'tada' => 'Tada',
					'wobble' => 'Wobble',
					'jello' => 'Jello',
					'bounceIn' => 'Bounce In',
					'bounceInDown' => 'Bounce In Down',
					'bounceInLeft' => 'Bounce In Left',
					'bounceInRight' => 'Bounce In Right',
					'bounceInUp' => 'Bounce In Up',
					'fadeIn' => 'Fade In',
					'fadeInDown' => 'Fade In Down',
					'fadeInDownBig' => 'Fade In Down Big',
					'fadeInLeft' => 'Fade In Left',
					'fadeInLeftBig' => 'Fade In Left Big',
					'fadeInRight' => 'Fade In Right',
					'fadeInRightBig' => 'Fade In Right Big',
					'fadeInUp' => 'Fade In Up',
					'fadeInUpBig' => 'Fade In Up Big',
					'flip' => 'Flip',
					'flipInX' => 'Flip In X',
					'flipInY' => 'Flip In Y',
					'lightSpeedIn' => 'Light Speed In',
					'rotateIn' => 'Rotate In',
					'rotateInDownLeft' => 'Rotate In Down Left',
					'rotateInDownRight' => 'Rotate In Down Right',
					'rotateInUpLeft' => 'Rotate In Up Left',
					'rotateInUpRight' => 'Rotate In Up Right',
					'rollIn' => 'Roll In',
					'zoomIn' => 'Zoom In',
					'zoomInDown' => 'Zoom In Down',
					'zoomInLeft' => 'Zoom In Left',
					'zoomInRight' => 'Zoom In Right',
					'zoomInUp' => 'Zoom In Up',
					'slideInDown' => 'Slide In Down',
					'slideInLeft' => 'Slide In Left',
					'slideInRight' => 'Slide In Right',
					'slideInUp' => 'Slide In Up',
				)
			),
			'hide_animation' => array(
				'type' => 'select',
				'label' => __pl('obj_hide_animation_label'),
				'default' => '',
				'list' => array(
					'' => 'None',
					'auto' => 'Auto',
					'bounce' => 'Bounce',
					'pulse' => 'Pulse',
					'rubberBand' => 'Rubber Band',
					'shake' => 'Shake',
					'swing' => 'Swing',
					'tada' => 'Tada',
					'wobble' => 'Wobble',
					'jello' => 'Jello',
					'bounceOut' => 'Bounce Out',
					'bounceOutDown' => 'Bounce Out Down',
					'bounceOutLeft' => 'Bounce Out Left',
					'bounceOutRight' => 'Bounce Out Right',
					'bounceOutUp' => 'Bounce Out Up',
					'fadeOut' => 'Fade Out',
					'fadeOutDown' => 'Fade Out Down',
					'fadeOutDownBig' => 'Fade Out Down Big',
					'fadeOutLeft' => 'Fade Out Left',
					'fadeOutLeftBig' => 'Fade Out Left Big',
					'fadeOutRight' => 'Fade Out Right',
					'fadeOutRightBig' => 'Fade Out Right Big',
					'fadeOutUp' => 'Fade Out Up',
					'fadeOutUpBig' => 'Fade Out Up Big',
					'flip' => 'Flip',
					'flipOutX' => 'Flip Out X',
					'flipOutY' => 'Flip Out Y',
					'lightSpeedOut' => 'Light Speed Out',
					'rotateOut' => 'Rotate Out',
					'rotateOutDownLeft' => 'Rotate Out Down Left',
					'rotateOutDownRight' => 'Rotate Out Down Right',
					'rotateOutUpLeft' => 'Rotate Out Up Left',
					'rotateOutUpRight' => 'Rotate Out Up Right',
					'rollOut' => 'Roll Out',
					'zoomOut' => 'Zoom Out',
					'zoomOutDown' => 'Zoom Out Down',
					'zoomOutLeft' => 'Zoom Out Left',
					'zoomOutRight' => 'Zoom Out Right',
					'zoomOutUp' => 'Zoom Out Up',
					'slideOutDown' => 'Slide Out Down',
					'slideOutLeft' => 'Slide Out Left',
					'slideOutRight' => 'Slide Out Right',
					'slideOutUp' => 'Slide Out Up',
				)
			) */
		),
		'modal_container_style' => [
			'modal_style' => array(
				'type' => 'radio',
				'label' => __pl('obj_style'),
				'default' => 'modal-dark',
				'list' => array(
					'modal-dark' => __pl('dark'),
					'modal-light' => __pl('light'),
					'custom' => __pl('custom')
				)
			),
			'modal_shadow_color' => array(
				'type' => 'color',
				'label' => __pl('obj_shadow_color_label'),
				'default' => '#0b0b0b',
				'req' => array(
					'modal_style' => 'custom'
				),
				'css' => ['{{element}} .pagelayer-modal-content' => 'background-color: {{val}}'],
			),
			'modal_content_body_color' => array(
				'type' => 'color',
				'label' => __pl('obj_content_color_label'),
				'default' => '#000000',
				'req' => array(
					'modal_style' => 'custom'
				),
				'css' => ['{{element}} .pagelayer-modal-body' => 'color: {{val}}'],
			),
			'modal_content_color' => array(
				'type' => 'color',
				'label' => __pl('content body bg color'),
				'default' => '#ffffff',
				'req' => array(
					'modal_style' => 'custom'
				),
				'css' => ['{{element}} .pagelayer-modal-body' => 'background-color: {{val}}'],
			),
			'modal_close_color' => array(
				'type' => 'color',
				'label' => __pl('Close button color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-modal-close::before' => 'background-color:{{val}}', '{{element}} .pagelayer-modal-close::after' => 'background-color:{{val}}'],
				'req' => array(
					'modal_style' => 'custom',
				)
			),
		],
		'modal_title_style' => [
			'modal_title_bgcolor' => array(
				'type' => 'color',
				'label' =>  __pl('title') . ' ' .__pl('obj_shadow_color_label'),
				'default' => '#3D54DF',
				'css' => ['{{element}} .pagelayer-modal-title' => 'background-color: {{val}}'],
				'req' => [
					'!modal_title' => ''
				],
			),
			'modal_title_color' => array(
				'type' => 'color',
				'label' => __pl('title') . ' ' . __pl('list_text_color_label'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-modal-title' => 'color: {{val}}'],
				'req' => [
					'!modal_title' => ''
				],
			)
		],
		'styles' => [
			'modal_container_style' => __pl('modal_container_style'),
			'modal_title_style' => __pl('modal_title_style'),
		]
	)
);

// Splash Screen
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_splash', array(
		'name' => __pl('Splash Screen'),
		'group' => 'other',
		'func' => 'pagelayer_sc_splash',
		'innerHTML' => 'content',
		'html' => '<div class="pagelayer-splash-container  pagelayer-splash-{{modal_style}}">
			<span class="pagelayer-splash-close"></span>
			<div class="pagelayer-splash-content">
				{{content}}
			</div>
		</div>',
		'params' => array(
			'content' => array(
				'type' => 'editor',
				'label' => __pl('obj_content'),
				'text' => __pl('edit') . ' ' . __pl('popup_name'),
				'default' => __pl('content_with_tags_default'),
			),
			'delay' => array(
				'type' => 'text',
				'label' => __pl('popup_delay_label'),
				'default' => '1000'
			),
			'display' => array(
				'type' => 'select',
				'label' => __pl('display'),
				'default' => 'once',
				'list' => array(
					'always' => __pl('always'),
					'once' => __pl('once')
				)
			),
			'modal_style' => array(
				'type' => 'radio',
				'label' => __pl('obj_style'),
				'default' => 'dark',
				'list' => array(
					'dark' => __pl('dark'),
					'light' => __pl('light'),
					'custom' => __pl('custom')
				)
			),
			'modal_shadow_color' => array(
				'type' => 'color',
				'label' => __pl('obj_shadow_color_label'),
				'default' => '#0b0b0b',
				'css' => ['{{element}} .pagelayer-splash-container ' => 'background:{{val}}'],
				'req' => array(
					'modal_style' => 'custom'
				)
			),
			'modal_content_color' => array(
				'type' => 'color',
				'label' => __pl('obj_content_color_label'),
				'default' => '#0b0b0b',
				'css' => ['{{element}} .pagelayer-splash-container ' => 'color:{{val}}'],
				'req' => array(
					'modal_style' => 'custom'
				)
			),
			'modal_close_color' => array(
				'type' => 'color',
				'label' => __pl('Close button color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-splash-close::after, {{element}} .pagelayer-splash-close::before ' => 'background-color:{{val}}'],
				'req' => array(
					'modal_style' => 'custom'
				)
			),
			'modal_content_width' => array(
				'type' => 'slider',
				'label' => __pl('Splash content width'),
				'default' => '90',
				'css' => ['{{element}} .pagelayer-splash-content' => 'width:{{val}}%'],
			),
			'modal_content_padding' => array(
				'type' => 'padding',
				'label' => __pl('Splash content padding'),
				'screen' => 1,
				'units' => ['px', 'em', '%'],
				'css' => ['{{element}} .pagelayer-splash-content' => 'padding-top: {{val[0]}}; padding-right: {{val[1]}}; padding-bottom: {{val[2]}}; padding-left: {{val[3]}}'],
			),
		)
	)
);

// Chart
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_chart', array(
		'name' => __pl('chart'),
		'group' => 'other',
		'func' => 'pagelayer_sc_chart',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('obj_title_label'),
				'default' => 'Company Performance'
			),
			'type' => array(
				'type' => 'select',
				'label' => __pl('google_charts_type_label'),
				'desc' => __pl('google_charts_type_desc'),
				'default' => 'ColumnChart',
				'list' => array(
					'ColumnChart' => __pl('google_charts_type_list_column'),
					'BarChart' => __pl('google_charts_type_list_bar'),
					'AreaChart' => __pl('google_charts_type_list_area'),
					'SteppedAreaChart' => __pl('google_charts_type_list_stepped'),
					'PieChart' => __pl('google_charts_type_list_pie'),
					'PieChart3D' => __pl('google_charts_type_list3d'),
					'LineChart' => __pl('google_charts_type_list_line'),
					'Histogram' => __pl('google_charts_type_list_histogram')
				)
			),
			'donut' => array(
				'type' => 'checkbox',
				'label' => __pl('google_charts_donut_label'),
				'default' => '',
				'req' => array(
					'type',
					'val' =>'PieChart'
				)
			),
			'colors' => array(
				'type' => 'text',
				'label' => __pl('google_charts_colors_label'),
				'desc' => __pl('google_charts_colors_desc'),
			),
			'transparency' => array(
				'type' => 'checkbox',
				'label' => __pl('google_charts_transparency_label'),
			),
			'table' => array(
				'type' => 'textarea',
				'label' => __pl('obj_table_data_label'),
				'desc' => __pl('google_charts_data_desc'),
				'default' => 'Year,Sales,Expenses<br />2004,1000,400<br />2005,1170,460<br />2006,660,1120<br />2007,1030,540',
			)
		)
	)
);

// Countdown Timer
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_countdown', array(
		'name' => __pl('Countdown Timer'),
		'group' => 'other',
		'func' => 'pagelayer_sc_countdown',
		'html' => '<div class="pagelayer-countdown-container">
			<center>
			<div class="pagelayer-countdown-days pagelayer-countdown-item">
				<div class="pagelayer-days-count pagelayer-count" />
				<span class="pagelayer-countdown-name">Days</span>
			</div>
			<div class="pagelayer-countdown-hours pagelayer-countdown-item">
				<div class="pagelayer-hours-count pagelayer-count" />
				<span class="pagelayer-countdown-name">Hours</span>
			</div>
			<div class="pagelayer-countdown-minutes pagelayer-countdown-item">
				<div class="pagelayer-minutes-count pagelayer-count" />
				<span class="pagelayer-countdown-name">Minutes</span>
			</div>
			<div class="pagelayer-countdown-seconds pagelayer-countdown-item">
				<div class="pagelayer-seconds-count pagelayer-count" />
				<span class="pagelayer-countdown-name">Seconds</span>
			</div>
			</center>
		</div>',
		'params' => array(
			 'date' => array(
				'type' => 'datetime',
				'displayMode' => 'datetime', // date | datetime (default)
				'returnMode' => 'YYYY-MM-DD H:m:s', // mysql format uses here (default: Y-m-d H:i:s )
				'label' => __pl('date_picker_label'),
				'default' => '',
			 ),
			 'time_zone' => array(
				 'type' => 'select',
				 'label' => __pl('countdown_time_zone'),
				'default' => 'server_time',
				'list' => array(
					'server_time' => __pl('server_time'),
					'user_local' => __pl('user_local')
				),
			 ),
			'format' => array(
				'type' => 'text',
				'label' => __pl('format'),
				'default' => 'yowdHMS',
				'desc' => __pl('countdown_format_description')
			),
			'block_color' => array(
				'type' => 'color',
				'label' => __pl('bg_color'),
				'default' => '#eeeeee',
			),
			'font_color' => array(
				'type' => 'color',
				'label' => __pl('text_color'),
				'default' => '#333333',
			),
			'blocks_size' => array(
				'type' => 'spinner',
				'label' => __pl('countdown_blocks_size'),
				'min' => 1,
				'step' => 1,
				'max' => 480,
				'default' => 130,
			),
			'digits_font_size' => array(
				'type' => 'slider',
				'label' => __pl('countdown_digits_size'),
				'min' => 8,
				'step' => 1,
				'max' => 300,
				'default' => 40
			),
			'labels_font_size' => array(
				'type' => 'slider',
				'label' => __pl('countdown_labels_size'),
				'min' => 6,
				'step' => 1,
				'max' => 96,
				'default' => 11
			),
			'blocks_space' => array(
				'type' => 'spinner',
				'label' => __pl('countdown_block_space'),
				'min' => 0,
				'step' => 1,
				'max' => 160,
				'default' => 10,
			),
		 )
	)
);

// Pricing Table
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_pricing', array(
		'name' => __pl('Pricing Table'),
		'group' => 'other',
		'func' =>  'pagelayer_sc_pricing',
		'holder' => '.pagelayer-pricing-ul',
		'html' =>  '<div class="pagelayer-pricing-details">
			<div if="{{ribbon_text}}" class="pagelayer-pricing-ribbon">
				{{ribbon_text}}
			</div>
			<h3 if="{{plan_title}}" class="pagelayer-pricing-type">{{plan_title}}</h3>
			<h4 if="{{plan_sub_title}}" class="pagelayer-pricing-sub-title">{{plan_sub_title}}</h4>
			<div class="pagelayer-pricing-rate-section">
				<h4 if="{{original_price}}" class="pagelayer-pricing-price pagelayer-pricing-original">
					<span if="{{currency}}" class="pagelayer-pricing-currency pagelayer-pricing-currency-{{currency_position}}">{{currency}}</span>
					<span class="pagelayer-pricing-rate" >{{original_price}}</span>
				</h4>
				<h2 class="pagelayer-pricing-price">
					<span if="{{currency}}" class="pagelayer-pricing-currency pagelayer-pricing-currency-{{currency_position}}">{{currency}}</span>
					<span if="{{price}}" class="pagelayer-pricing-rate">{{price}}</span>
				</h2>
			</div>
			<p if="{{period}}" class="pagelayer-pricing-duration">per {{period}}</p>
		</div>
		<div class="pagelayer-pricing-features">
			<ul class="pagelayer-pricing-ul"></ul>
			<a if="{{button_url}}" href="{{button_url}}" class="pagelayer-pricing-btn pagelayer-button pagelayer-ele-link">{{button_text}}</a>
			<p if="{{additional_info}}" class="pagelayer-pricing-additional">{{additional_info}}</p>
		</div>',
		'params' => array(
			'plan_title' => array(
				'type' => 'text',
				'label' => __pl('pricing_type_label'),
				'default' => 'Standard',
			),
			'plan_sub_title' => array(
				'type' => 'text',
				'label' => __pl('pricing_subtitle_label'),
				'default' => 'For beginners',
			),
			'currency' => array(
				'type' => 'text',
				'label' => __pl('pricing_currency_type_label'),
				'default' => '$',
			),
			'price' => array(
				'type' => 'text',
				'label' => __pl('pricing_value_label'),
				'default' => '49',
			),
			'sale' => array(
				'type' => 'checkbox',
				'label' => __pl('sale'),
			),
			'original_price' => array(
				'type' => 'text',
				'label' => __pl('pricing_old_value_label'),
				'default' => '100',
				'css' => ['{{element}} .pagelayer-pricing-original '=> 'display:inline-block;'],
				'req' => array(
					'sale' => 'true'
				)
			),
			'period' => array(
				'type' => 'text',
				'label' => __pl('pricing_period_label'),
				'default' => 'month',
			),
			'elements' => array(
				'type' => 'group',
				'label' => __pl('Features Item'),
				'sc' => PAGELAYER_SC_PREFIX.'_list_item',
				'item_label' => array(
					'default' => __pl('Features Item'),
					'param' => 'text'
				),
				'count' => 2,
				'text' => __pl('Add Feature'),
			),
			'button_text' => array(
				'type' => 'text',
				'label' => __pl('button_text_label'),
				'default' => 'Buy',
			),
			'button_url' => array(
				'type' => 'link',
				'label' => __pl('pricing_btn_url_label'),
			),
			'additional_info' => array(
				'type' => 'textarea',
				'label' => __pl('additional_info'),
				'default' => 'Any Additional Info',
			),
			'ribbon' => array(
				'type' => 'checkbox',
				'label' => __pl('ribbion_display_label'),
			),
			'ribbon_text' => array(
				'type' => 'text',
				'label' => __pl('pricing_ribbion_text'),
				'default' => 'popular',
				'css' => ['{{element}} .pagelayer-pricing-ribbon'=> 'display:inline-block;'],
				'req' => array(
					'ribbon' => 'true'
				)
			),
		),
		//styles
		'currency_style' => [
			'currency_color' => array(
				'type' => 'color',
				'label' => __pl('price_currency_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-price .pagelayer-pricing-currency' => 'color:{{val}}'],
			),
			'currency_size' => array(
				'label' => __pl('price_currency_size'),
				'type' => 'slider',
				'min' => 0,
				'max' => 60,
				'default' => 20,
				'css' => ['{{element}}  .pagelayer-pricing-price .pagelayer-pricing-currency' => 'font-size:{{val}}px;'],
			),
			'currency_position' => array(
				'type' => 'radio',
				'label' => __pl('currency_position_label'),
				'default' => 'top',
				'list' => array(
					'top' => __pl('top'),
					'middle' => __pl('middle'),
					'bottom' => __pl('bottom'),
				),
			),
		],
		'price_style' => [
			'price_size' => array(
				'label' => __pl('plan_price_size'),
				'type' => 'slider',
				'min' => 0,
				'max' => 60,
				'default' => 45,
				'css' => ['{{element}}  .pagelayer-pricing-price .pagelayer-pricing-rate' => 'font-size:{{val}}px;'],
			),
			'price_sale_size' => array(
				'label' => __pl('old_price_size'),
				'type' => 'slider',
				'min' => 0,
				'max' => 60,
				'default' => 20,
				'css' => ['{{element}}  .pagelayer-pricing-original .pagelayer-pricing-rate' => 'font-size:{{val}}px;'],
			),
			'price_margin' => array(
				'type' => 'padding',
				'label' => __pl('price_margin'),
				'css' =>  ['{{element}} .pagelayer-pricing-rate-section' => 'margin: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;'],
			),
			'price_padding' => array(
				'type' => 'padding',
				'label' => __pl('price_padding'),
				'css' =>  ['{{element}} .pagelayer-pricing-rate-section' => 'padding: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;'],
			),
			'price_state' => array(
				'type' => 'radio',
				'label' => __pl('price_state_label'),
				'default' => 'normal',
				'list' => array(
					'normal' => __pl('Normal'),
					'hover' => __pl('Hover'),
				),
			),
			'price_line_height' => array(
				'label' => __pl('price_line_height'),
				'type' => 'slider',
				'min' => 0,
				'max' => 500,
				'default' => 30,
				'css' => ['{{element}}  .pagelayer-pricing-price .pagelayer-pricing-currency' => 'line-height:{{val}}%;'],
			),
			'price_color' => array(
				'type' => 'color',
				'label' => __pl('price_value_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-price .pagelayer-pricing-rate ' => 'color:{{val}}'],
				'req' => ['price_state' => 'normal'],
			),
			'old_price_color' => array(
				'type' => 'color',
				'label' => __pl('old_price_value_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-price.pagelayer-pricing-original .pagelayer-pricing-rate ' => 'color:{{val}}'],
				'req' => ['price_state' => 'normal'],
			),
			'price_background_color' => array(
				'type' => 'color',
				'label' => __pl('price_background_color'),
				'default' => '#ffffff01',
				'css' => ['{{element}} .pagelayer-pricing-rate-section' => 'background-color:{{val}}'],
				'req' => ['price_state' => 'normal'],
			),
			'price_color_hover' => array(
				'type' => 'color',
				'label' => __pl('price_value_color_hover'),
				'default' => '#000000',
				'css' => ['{{element}} .pagelayer-pricing-price .pagelayer-pricing-rate' => 'color:{{val}}'],
				'req' => ['price_state' => 'hover'],
			),
			'price_background_color_hover' => array(
				'type' => 'color',
				'label' => __pl('price_background_color_hover'),
				'default' => '#ffffff01',
				'css' => ['{{element}} .pagelayer-pricing-rate-section' => 'background-color:{{val}}'],
				'req' => ['price_state' => 'hover'],
			),
			'price_border_type' => array(
				'type' => 'select',
				'label' => __pl('price_border_type'),
				'css' => ['{{element}} .pagelayer-pricing-rate-section' =>'border-style: {{val}};'],
				'list' => [
					'' => __pl('none'),
					'solid' => __pl('solid'),
					'double' => __pl('double'),
					'dotted' => __pl('dotted'),
					'dashed' => __pl('dashed'),
					'groove' => __pl('groove'),
				],
			),
			'price_border_color' => array(
				'type' => 'color',
				'label' => __pl('price_value_border_color'),
				'default' => '#42414f',
				'css' => ['{{element}} .pagelayer-pricing-rate-section' => 'border-color: {{val}};'],
				'req' => ['!price_border_type' => '']
			),
			'price_border_width' => array(
				'type' => 'padding',
				'label' => __pl('price_value_border_width'),
				'css' =>  ['{{element}} .pagelayer-pricing-rate-section' =>'border-top-width: {{val[0]}}px; border-right-width: {{val[1]}}px; border-bottom-width: {{val[2]}}px; border-left-width: {{val[3]}}px;'],
				'req' => ['!price_border_type' => '']
			),
			'price_border_radius' => array(
				'type' => 'padding',
				'label' => __pl('price_value_border_radius'),
				'css' =>  ['{{element}} .pagelayer-pricing-rate-section' => 'border-radius: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px; -webkit-border-radius:  {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;-moz-border-radius: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;'],
				'req' => ['!price_border_type' => '']
			),
		],
		'title_style' => [
			'title_color' => array(
				'type' => 'color',
				'label' => __pl('plan_title_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-type' => 'color:{{val}}'],
			),
			'subtitle_color' => array(
				'type' => 'color',
				'label' => __pl('plan_subtitle_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-sub-title' => 'color:{{val}}'],
			),
			'title_size' => array(
				'label' => __pl('plan_title_size'),
				'type' => 'slider',
				'min' => 0,
				'max' => 50,
				'default' => 18,
				'css' => ['{{element}}  .pagelayer-pricing-type' => 'font-size:{{val}}px;'],
			),
		],
		'period_style' => [
			'period_color' => array(
				'type' => 'color',
				'label' => __pl('plan_period_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-duration' => 'color:{{val}}'],
			),
			'period_size' => array(
				'label' => __pl('plan_period_size'),
				'type' => 'slider',
				'min' => 0,
				'max' => 50,
				'default' => 18,
				'css' => ['{{element}}  .pagelayer-pricing-duration' => 'font-size:{{val}}px;'],
			),
		],
		'header_style' => [
			'header_background_color' => array(
				'type' => 'color',
				'label' => __pl('plan_header_background_color'),
				'default' => '#1e1558',
				'css' => ['{{element}} .pagelayer-pricing-details' => 'background-color:{{val}}'],
			),
			'header_padding' => array(
				'label' => __pl('plan_price_padding'),
				'type' => 'slider',
				'min' => 0,
				'max' => 200,
				'default' => 10,
				'css' => ['{{element}}  .pagelayer-pricing-details' => 'padding-top:{{val}}px; padding-bottom:{{val}}px;'],
			),
		],
		'feature_style' => [
			'features_background_color' => array(
				'type' => 'color',
				'label' => __pl('plan_features_background_color'),
				'default' => '#f3f6f6ff',
				'css' => ['{{element}} .pagelayer-pricing-features' => 'background-color:{{val}}'],
			),
			'features_text_color' => array(
				'type' => 'color',
				'label' => __pl('plan_features_text_color'),
				'default' => '#e5e5e5',
				'css' => ['{{element}} .pagelayer-pricing-details' => 'color:{{val}}'],
			),
			'features_padding' => array(
				'label' => __pl('plan_features_padding'),
				'type' => 'slider',
				'min' => 0,
				'max' => 200,
				'default' => 10,
				'css' => ['{{element}}  .pagelayer-pricing-features' => 'padding-top:{{val}}px; padding-bottom:{{val}}px;'],
			),
		],
		'button_style' => [
			'btn-state' => array(
				'type' => 'radio',
				'label' => __pl('price_state_label'),
				'default' => 'normal',
				'list' => array(
					'normal' => __pl('Normal'),
					'hover' => __pl('Hover'),
				),
			),
			'button_text_color' => array(
				'type' => 'color',
				'label' => __pl('plan_button_text_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-btn' => 'color:{{val}}'],
				'req' => ['btn-state' => 'normal'],
			),
			'button_background_color' => array(
				'type' => 'color',
				'label' => __pl('plan_button_background_color'),
				'default' => '#1e1558',
				'css' => ['{{element}} .pagelayer-pricing-btn' => 'background-color:{{val}}'],
				'req' => ['btn-state' => 'normal'],
			),
			'button_text_color_hover' => array(
				'type' => 'color',
				'label' => __pl('plan_button_text_color_hover'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-btn:hover' => 'color:{{val}}'],
				'req' => ['btn-state' => 'hover'],
			),
			'button_background_color_hover' => array(
				'type' => 'color',
				'label' => __pl('plan_button_background_color_hover'),
				'default' => '#1e1558',
				'css' => ['{{element}} .pagelayer-pricing-btn:hover' => 'background-color:{{val}}'],
				'req' => ['btn-state' => 'hover'],
			),
			'button_border_type' => array(
				'type' => 'select',
				'label' => __pl('price_btn_border_type'),
				'css' => ['{{element}} .pagelayer-pricing-btn' =>'border-style: {{val}};'],
				'list' => [
					'' => __pl('none'),
					'solid' => __pl('solid'),
					'double' => __pl('double'),
					'dotted' => __pl('dotted'),
					'dashed' => __pl('dashed'),
					'groove' => __pl('groove'),
				],
			),
			'button_border_color' => array(
				'type' => 'color',
				'label' => __pl('price_btn_border_color'),
				'default' => '#42414f',
				'css' => ['{{element}} .pagelayer-pricing-btn' => 'border-color: {{val}};'],
				'req' => ['!button_border_type' => '']
			),
			'button_border_width' => array(
				'type' => 'padding',
				'label' => __pl('price_btn_border_width'),
				'css' =>  ['{{element}} .pagelayer-pricing-btn' =>'border-top-width: {{val[0]}}px; border-right-width: {{val[1]}}px; border-bottom-width: {{val[2]}}px; border-left-width: {{val[3]}}px;'],
				'req' => ['!button_border_type' => '']
			),
			'button_border_radius' => array(
				'type' => 'padding',
				'label' => __pl('price_btn_border_radius'),
				'css' =>  ['{{element}} .pagelayer-pricing-btn' => 'border-radius: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px; -webkit-border-radius:  {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;-moz-border-radius: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;'],
				'req' => ['!button_border_type' => '']
			),
			'button_padding' => array(
				'type' => 'padding',
				'label' => __pl('price_btn_padding'),
				'css' =>  ['{{element}} .pagelayer-pricing-btn' => 'padding: {{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;'],
			),
		],
		'ribbon_style' => [
			'ribbon_text_size' => array(
				'type' => 'slider',
				'label' => __pl('ribbon_text_size'),
				'min' => '0',
				'max' => '50',
				'css' => ['{{element}} .pagelayer-pricing-ribbon' => 'font-size:{{val}}px;'],
			),
			'ribbon_background' => array(
				'type' => 'color',
				'label' => __pl('ribbon_background_color'),
				'default' => '#ce4210ff',
				'css' => ['{{element}} .pagelayer-pricing-ribbon' => 'background-color:{{val}}'],
			),
			'ribbon_text_color' => array(
				'type' => 'color',
				'label' => __pl('ribbon_text_color'),
				'default' => '#ffffff',
				'css' => ['{{element}} .pagelayer-pricing-ribbon' => 'color:{{val}}'],
			),
		],
		'styles' => [
			'currency_style' => __pl('currency_style'),
			'price_style' => __pl('price_style'),
			'title_style' => __pl('title_style'),
			'period_style' => __pl('period_style'),
			'header_style' => __pl('header_style'),
			'feature_style' => __pl('feature_style'),
			'button_style' => __pl('button_style'),
			'ribbon_style' => __pl('ribbon_style'),
		],
	)
);

// Contact Form
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_contact', array(
		'name' => __pl('Contact Form'),
		'group' => 'other',
		'func' => 'pagelayer_sc_contact',
		'params' => array(
			'elements' => array(
				'type' => 'group',
				'sc' => PAGELAYER_SC_PREFIX.'_contact_item',
				'items' => array(
					'label' => array(
						'default' => __pl('label'),
						'param' => 'title'
					),
					'count' => 1
				),
				'text' => __pl('Add New Field'),
			),
			'customize_input_filed' => array(
				'type' => 'checkbox',
				'label' => __pl('customize_style_fields'),
			),
			'label_color' => array(
				'type' => 'color',
				'label' => __pl('label_color'),
				'default' => '',
				'req' => array(
					'customize_input_filed' => 'true'
				)
			),
			'placeholder_color' => array(
				'type' => 'color',
				'label' => __pl('placeholder_color'),
				'default' => '',
				'req' => array(
					'customize_input_filed' => 'true'
				)
			),
			'input_height' => array(
				'type' => 'spinner',
				'label' => __pl('text_field_height'),
				'default' => '',
				'min' => 1,
				'max' => 1000,
				'step' => 1,
				'req' => array(
					'customize_input_filed' => 'true'
				)
			),
			'input_color' => array(
				'type' => 'color',
				'label' => __pl('text_color'),
				'default' => '',
				'req' => array(
					'customize_input_filed' => 'true'
				)
			),
			'border_width' => array(
				'type' => 'spinner',
				'label' => __pl('border_width'),
				'default' => '',
				'min' => 1,
				'max' => 1000,
				'step' => 1,
				'req' => array(
					'customize_input_filed' => 'true'
				)
			),
			'border_color' => array(
				'type' => 'color',
				'label' => __pl('border_color'),
				'default' => '',
				'req' => array(
					'customize_input_filed' => 'true'
				)
			),
			'border_radius' => array(
				'type' => 'spinner',
				'label' => __pl('border_radius'),
				'default' => '',
				'min' => 1,
				'max' => 1000,
				'step' => 1,
				'req' => array(
					'customize_input_filed' => 'true'
				)
			),
			'input_hover' => array(
				'type' => 'checkbox',
				'label' => __pl('focus_fields_label'),
			),
			'hover_border_color' => array(
				'type' => 'color',
				'label' => __pl('border_color'),
				'default' => '',
				'req' => array(
					'input_hover' => 'true'
				)
			),
			'box_checked' => array(
				'type' => 'checkbox',
				'label' => __pl('checkbox_selected_style'),
			),
			'box_color' => array(
				'type' => 'color',
				'label' => __pl('color'),
				'default' => '',
				'req' => array(
					'box_checked' => 'true'
				)
			),
			'box_bg_color' => array(
				'type' => 'color',
				'label' => __pl('bg_color'),
				'default' => '',
				'req' => array(
					'box_checked' => 'true'
				)
			),
			'submit' => array(
				'type' => 'text',
				'label' => __pl('Submit button label'),
				'default' => __pl('submit'),
			),
			'submit_font_family' => array(
				'type' => 'select',
				'label' => __pl('opt_google_fonts_family'),
				'default' => 'default',
				'list' => pagelayer_font_family(),
			),
			'submit_color' => array(
				'type' => 'color',
				'label' => __pl('button_text_color'),
				'default' => ''
			),
			'submit_bg_color' => array(
				'type' => 'color',
				'label' => __pl('button_background_color'),
				'default' => ''
			),
			'submit_hover' => array(
				'type' => 'checkbox',
				'label' => __pl('hover_effect_button_label'),
			),
			'submit_hover_color' => array(
				'type' => 'color',
				'label' => __pl('button_text_color'),
				'default' => '',
				'req' => array(
					'submit_hover' => 'true'
				)
			),
			'submit_hover_bg_color' => array(
				'type' => 'color',
				'label' => __pl('button_background_color'),
				'default' => '',
				'req' => array(
					'submit_hover' => 'true'
				)
			),
			'stretch' => array(
				'type' => 'checkbox',
				'label' => __pl('stretch_button_label'),
			),
			'redirect_show' => array(
				'type' => 'checkbox',
				'label' => __pl('redirect_url'),
			),
			'redirecturl' => array(
				'type' => 'link',
				'label' => __pl('redirect_urllabel'),
				'desc' => __pl('redirect_urldesc'),
				'req' => array(
					'redirect_show' => 'true'
				)
			),
			'captcha' => array(
				'type' => 'checkbox',
				'label' => __pl('Use reCAPTCHA'),
				'default' => 'true',
				'desc' => __pl('Protect this form from spam and abuse. Configure Google reCAPTCHA in plugin settings first.'),
			),
			'position' => array(
				'type' => 'radio',
				'label' => __pl('alignment'),
				'default' => 'default',
				'list' => array(
					'default' => __pl('default'),
					'left' => __pl('left'),
					'right' => __pl('right')
				),
			),
			'form' => array(
				'type' => 'text',
				'label' => __pl('Form ID'),
				'desc' => __pl('Is used in e-mail template'),
			),
			'name' => array(
				'type' => 'text',
				'label' => __pl('Form name'),
				'default' => __pl('Contact Form'),
				'desc' => __pl('Is used in e-mail subject'),
			),
		)
	)
);

// Site Title
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_title', array(
		'name' => __pl('Site Title'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_title',
		'html' => '<div class="pagelayer-site-title">
			<a href="'.get_site_url().'" class="pagelayer-site-title-link pagelayer-ele-link">
				<img if="{{logo_img}}" src="{{{logo_img-url}}}" class="pagelayer-site-title-img" />
				<span class="pagelayer-site-title-name">{{site_name}}</span>
			</a>
		<div>',
		'params' => array(
			'site_name' => array(
				'type' => 'text',
				'label' => __pl('site_title'),
				'desc' => __pl('site_title_desc'),
				'default' => get_bloginfo( 'name' ),
			),
			'align' => array(
				'type' => 'radio',
				'label' => __pl('obj_align_label'),
				'default' => 'center',
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right')
				),
				'css' => ['{{element}} div' => 'text-align:{{val}};'],
			),
			'font_size' => array(
				'type' => 'spinner',
				'label' => 'Font Size',
				'default' => '',
				'min' => 1,
				'max' => 1000,
				'step' => 1,
				'css' => ['{{element}} span' => 'font-size:{{val}}px;'],
			),
			'color' => array(
				'type' => 'color',
				'label' => 'Font Color',
				'default' => '',
				'css' => ['{{element}} span' => 'color:{{val}};'],
			),
			'site_logo' => array(
				'type' => 'checkbox',
				'label' => __pl('site_logo'),
				'desc' => __pl('site_logo_desc'),
			),
			'logo_img' => array(
				'type' => 'image',
				'label' => __pl('site_logo_select'),
				'default' => '',
				'req' => array(
					'site_logo' => 'true'
				)
			),
			'logo_img_size' => array(
				'type' => 'dimension',
				'label' => __pl('site_logo_size'),
				'desc' => __pl('site_logo_size_desc'),
				'default' => '',
				'req' => array(
					'site_logo' => 'true'
				),
				'css' => ['{{element}} img' => 'height:{{val[0]}}px; width:{{val[1]}}px;'],
			)
		),
		'font_style' => [
			'site_title_font_family' => array(
				'type' => 'select',
				'label' => __pl('opt_google_fonts_family'),
				'default' => 'default',
				'list' => pagelayer_font_family(),
				'css' => ['{{element}} span' => 'font-family: {{val}};'],
			),
			'site_title_valign' => array(
				'type' => 'radio',
				'label' => __pl('site_title_position'),
				'default' => 'middle',
				'css' => ['{{element}} .pagelayer-site-title-name' => 'vertical-align: {{val}}'],
				'list' => array(
					'top' => __pl('top'),
					'middle' => __pl('middle'),
					'bottom' => __pl('bottom')
				),
				'req' => array(
					'site_logo' => 'true',
					'logo_position' => array('','row-reverse')
				)
			),
			'site_title_align' => array(
				'type' => 'radio',
				'label' => __pl('site_title_position'),
				'default' => 'center',
				'css' => ['{{element}} .pagelayer-site-title-name' => 'text-align: {{val}}'],
				'list' => array(
					'left' => __pl('left'),
					'center' => __pl('center'),
					'right' => __pl('right')
				),
				'req' => array(
					'site_logo' => 'true',
					'logo_position' => array('column','column-reverse')
				)
			)
		],
		'logo_style' => [
			'logo_position' => array(
				'type' => 'radio',
				'label' => __pl('site_logo_position'),
				'default' => 'left',
				'css' => ['{{element}} a' => 'flex-direction: {{val}}'],
				'list' => array(
					'' => __pl('left'),
					'row-reverse' => __pl('right'),
					'column' => __pl('top'),
					'column-reverse' => __pl('bottom')
				),
				'req' => array(
					'site_logo' => 'true'
				)
			),
			'space_logo' => array(
				'type' => 'padding',
				'label' => __pl('site_logo_margin'),
				'desc' => __pl('site_logo_margin_desc'),
				'req' => array(
					'site_logo' => 'true'
				),
				'css' => ['{{element}} img' => 'margin:{{val[0]}}px {{val[1]}}px {{val[2]}}px {{val[3]}}px;'],
			)
		],
		'styles' => [
			'logo_style' => __pl('logo_style'),
			'font_style' => __pl('font_style'),
		]
	)
);

// Primary Menu
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_menu', array(
		'name' => __pl('Primary Menu'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_menu',
		'html' => '<div class="pagelayer-wp-menu-container pagelayer-menu-alignment-{{align}}">
			</div>',
		'params' => array(
			'align' => array(
				'type' => 'radio',
				'label' => 'Alignment',
				'default' => 'right',
				'list' => array(
					'left' => 'Left',
					'center' => 'Center',
					'right' => 'Right'
				)
			),
			'font_size' => array(
				'type' => 'spinner',
				'label' => 'Font Size',
				'default' => '',
				'min' => 1,
				'max' => 1000,
				'step' => 1
			),
			'color' => array(
				'type' => 'color',
				'label' => 'Color',
				'default' => ''
			),
			'background_color' => array(
				'type' => 'color',
				'label' => 'Background Color',
				'default' => ''
			),
			'font_family' => array(
				'type' => 'select',
				'label' => 'Font Family',
				'default' => 'default',
				'list' => pagelayer_font_family(),
			),
			'item_spacing' => array(
				'type' => 'spinner',
				'label' => 'Menu Item Spacing',
				'default' => '',
				'min' => 0,
				'max' => 1000,
				'step' => 0.5
			),
			'line_height' => array(
				'type' => 'spinner',
				'label' => 'Menu Item Height',
				'default' => '',
				'min' => 0,
				'max' => 1000,
				'step' => 1
			),
			'li_submenu' => array(
				'type' => 'checkbox',
				'label' => 'Style for Dropdown Menu',
				'desc' => 'Check this to add style for dropdown menu items',
			),
			'dd_font_size' => array(
				'type' => 'spinner',
				'label' => 'Font Size',
				'default' => '',
				'min' => 1,
				'max' => 1000,
				'step' => 1,
				'req' => array(
					'li_submenu' => 'true'
				)
			),
			'dd_color' => array(
				'type' => 'color',
				'label' => 'Color',
				'default' => '',
				'req' => array(
					'li_submenu' => 'true'
				)
			),
			'dd_background_color' => array(
				'type' => 'color',
				'label' => 'Background Color',
				'default' => '',
				'req' => array(
					'li_submenu' => 'true'
				)
			),
			'dd_line_height' => array(
				'type' => 'spinner',
				'label' => 'Menu Item Height',
				'default' => '',
				'min' => 0,
				'max' => 1000,
				'step' => 1,
				'req' => array(
					'li_submenu' => 'true'
				)
			),
			'active_page' => array(
				'type' => 'checkbox',
				'label' => 'Active Page Effect',
				'desc' => 'Check this to add style for active menu item',
			),
			'active_page_bg' => array(
				'type' => 'color',
				'label' => 'Active Page Background',
				'default' => '',
				'req' => array(
					'active_page' => 'true'
				)
			),
			'active_page_color' => array(
				'type' => 'color',
				'label' => 'Active Page Color',
				'default' => '',
				'req' => array(
					'active_page' => 'true'
				)
			)
		)
	)
);

// Posts Grid
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_posts_grid', array(
		'name' => __pl('Posts Grid'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_posts_grid',
		'html' => '<div class="pagelayer-wp-posts-grid-container"></div>',
		'params' => array(
			'query_type' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_query_type_label'),
				'desc' => __pl('posts_grid_query_type_desc'),
				'default' => 'simple',
				'list' => array(
					'simple' => __pl('simple'),
					'custom' => __pl('posts_grid_custom_query_label'),
					'ids' => __pl('ids'),
				)
			),
			'post_type' => array(
				'type' => 'select',
				'label' => __pl('posts_grid_post_type_label'),
				'desc' => __pl('posts_grid_post_type_desc'),
				'list' => pagelayer_post_types(),
				'req' => array(
					'query_type' => 'simple'
				)
			),
			'category' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_category_label'),
				'desc' => __pl('posts_grid_category_desc'),
				'req' => array(
					'post_type' => 'post'
				)
			),
			'tag' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_tag_label'),
				'desc' => __pl('posts_grid_tag_desc'),
				'req' => array(
					'post_type' => 'post'
				)
			),
			'custom_tax' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_custom_tax_label'),
				'req' => array(
					'query_type' => 'simple'
				)
			),
			'custom_tax_field' => array(
				'type' => 'select',
				'label' => __pl('posts_grid_custom_tax_field_label'),
				'default' => 'slug',
				'list' => array(
					'term_id' => __pl('term_id'),
					'slug' => __pl('slug'),
					'name' => __pl('name')
				),
				'req' => array(
					'query_type' => 'simple'
				)
			),
			'custom_tax_terms' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_custom_tax_term_label'),
				'desc' => __pl('posts_grid_custom_tax_term_desc'),
				'req' => array(
					'query_type' => 'simple'
				)
			),
			'posts_per_page' => array(
				'type' => 'spinner',
				'label' => __pl('posts_grid_posts_per_page_label'),
				'default' => 4, // For backward compatibility in lite version must be 3 posts per page
				'min' => 1,
				'max' => 40,
				'step' => 1,
				'req' => array(
					'query_type' => 'simple'
				)
			),
			'posts_order' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_sort_order'),
				'default' => 'DESC',
				'list' => array(
					'ASC' => __pl('posts_grid_sort_order_ascending'),
					'DESC' => __pl('posts_grid_sort_order_descending')
				),
				'req' => array(
					'query_type' => 'simple'
				)
			),
			'custom_query' => array(
				'type' => 'textarea',
				'label' => __pl('posts_grid_custom_query_label'),
				'desc' => __pl('posts_grid_custom_query_desc'),
				'req' => array(
					'query_type' => 'custom'
				)
			),
			'ids' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_ids_label'),
				'desc' => __pl('posts_grid_ids_desc'),
				'req' => array(
					'query_type' => 'ids'
				)
			),
			'columns' => array(
				'type' => 'radio',
				'label' => __pl('columns_count'),
				'default' => 2,
				'list' => array( 
					1 => 1,
					2 => 2,
					3 => 3,
					4 => 4,
					6 => 6
				)
			),
			'template' => array(
				'type' => 'select',
				'label' => __pl('posts_grid_template_label'),
				'list' => array(),
			),
			'posts_gap' => array(
				'type' => 'slider',
				'label' => __pl('posts_grid_posts_gap_label'),
				'default' => 30,
				'min' => 0,
				'max' => 100,
				'step' => 10,
			),
			'show_featured_image' => array(
				'type' => 'checkbox',
				'label' => __pl('posts_grid_show_featured_image'),
				'default' => 'true',
			),
			'image_size' => array(
				'type' => 'radio',
				'label' => __pl('obj_image_size_label'),
				'default' => 'large',
				'list' => array(
					'full' => __pl('full'),
					'large' => __pl('large'),
					'medium' => __pl('medium'),
					'thumbnail' => __pl('thumbnail'),
					'custom' => __pl('custom')
				),
				'req' => array(
					'show_featured_image' => 'true'
				),
			),
			'image_custom_size' => array(
				'type' => 'text',
				'desc' => __pl('image_custom_size_label'),
				'req' => array(
					'image_size' => 'custom'
				),
			),
			'title_tag' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_title_tag'),
				'default' => 'h2',
				'list' => array(
					'h1' => 'H1',
					'h2' => 'H2',
					'h3' => 'H3',
					'h4' => 'H4',
					'h5' => 'H5',
					'hide' => __pl('posts_grid_title_tag_none'),
				)
			),
			'show_date_comments' => array(
				'type' => 'checkbox',
				'label' => __pl('posts_grid_show_date_comments'),
				'default' => 'true',
			),
			'show_content' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_show_content'),
				'default' => 'short',
				'list' => array(
					'short' => __pl('posts_grid_show_content_short'),
					'full' => __pl('posts_grid_show_content_full'),
					'excerpt' => __pl('posts_grid_show_content_excerpt'),
					'hide' => __pl('posts_grid_show_content_none'),
				)
			),
			'short_content_length' => array(
				'type' => 'slider',
				'label' => __pl('posts_grid_short_content_length'),
				'default' => 200,
				'min' => 0,
				'max' => 1000,
				'step' => 20,
				'req' => array(
					'show_content' => 'short'
				),
			),
			'read_more_text' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_read_more_text_label'),
				'default' => __pl('posts_grid_read_more_text')
			),
			'display_style' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_display_style'),
				'default' => 'show_all',
				'list' => array(
					'show_all' => __pl('show_all'),
					'load_more' => __pl('posts_grid_display_style_load_more'),
					'pagination' => __pl('posts_grid_display_style_pagination')
				)
			),
			'load_more_text' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_load_more_text_label'),
				'default' => __pl('posts_grid_load_more_text_default'), // "Load More"
				'req' => array(
					'display_style' => 'load_more'
				)
			),
			'filter' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_filter_label'),
				'desc' => __pl('posts_grid_filter_desc'),
				'default' => 'none',
				'list' => array(
					'none' => __pl('none'),
					'cats' => __pl('posts_grid_filter_by_first_tax'),
					'tags' => __pl('posts_grid_filter_by_second_tax'),
					'both' => __pl('posts_grid_filter_by_both')
				),
				'req' => array(
					'query_type' => 'simple'
				)
			),
			'filter_tax_1' => array(
				'type' => 'select',
				'label' => __pl('posts_grid_filter_first_tax_name'),
				'desc' => '',
				'default' => 'category',
				'list' => pagelayer_tax_list('category'),
				'req' => array(
					'filter' => array( 'cats', 'both' )
				)
			),
			'filter_tax_2' => array(
				'type' => 'select',
				'label' => __pl('posts_grid_filter_second_tax_name'),
				'desc' => '',
				'default' => 'post_tag',
				'list' => pagelayer_tax_list('post_tag'),
				'req' => array(
					'filter' => array( 'tags', 'both' )
				)
			),
			'filter_btn_color' => array(
				'type' => 'color',
				'label' => __pl('button_color_label'),
				'default' => 'pagelayer-btn-color-silver',
				'list' => array(
					'none' => __pl('none'),
					'pagelayer-btn-color-silver' => __pl('silver'),
					'pagelayer-btn-color-red' => __pl('red'),
					'pagelayer-btn-color-pink-dreams' => __pl('pink_dreams'),
					'pagelayer-btn-color-warm' => __pl('warm'),
					'pagelayer-btn-color-hot-summer' => __pl('hot_summer'),
					'pagelayer-btn-color-olive-garden' => __pl('olive_garden'),
					'pagelayer-btn-color-green-grass' => __pl('green_grass'),
					'pagelayer-btn-color-skyline' => __pl('skyline'),
					'pagelayer-btn-color-aqua-blue' => __pl('aqua_blue'),
					'pagelayer-btn-color-violet' => __pl('violet'),
					'pagelayer-btn-color-dark-grey' => __pl('dark_grey'),
					'pagelayer-btn-color-black' => __pl('black')
				),
				'req' => array(
					'!filter' => 'none'
				)
			),
			'filter_btn_divider' => array(
				'type' => 'text',
				'label' => __pl('filter_links_divider'),
				'default' => '/',
				'req' => array(
					'filter_btn_color' => 'none'
				)
			),
			'filter_cats_text' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_filter_first_tax_text_label'),
				'default' => __pl('categories') . ':',
				'req' => array(
					'filter' => array('cats', 'both')
				)
			),
			'filter_tags_text' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_filter_second_tax_text_label'),
				'default' => __pl('tags') . ':',
				'req' => array(
					'filter' => array('tags', 'both')
				)
			),
			'filter_all_text' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_filter_view_all_text_label'),
				'default' => __pl('all'),
				'req' => array(
					'!filter' => 'none'
				)
			)
		)
	)
);

// Posts Slider
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_posts_slider', array(
		'name' => __pl('Posts Slider'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_posts_slider',
		'html' => '<div class="pagelayer-wp-posts-slider-container">
			<div class="pagelayer-wp-posts-slider-ul"></div>
		</div>',
		'params' => array(
			'post_type' => array(
				'type' => 'select',
				'label' => __pl('posts_slider_post_types_label'),
				'default' => 'post',
				'list' => pagelayer_post_types(true),
			),
			'category' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_category_label'),
				'desc' => __pl('posts_grid_category_desc'),
				'req' => array(
					'post_type' => 'post'
				),
			),
			'tag' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_tag_label'),
				'desc' => __pl('posts_grid_tag_desc'),
				'req' => array(
					'post_type' => 'post'
				),
			),
			'custom_tax' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_custom_tax_label'),
				'default' => ''
			),
			'custom_tax_field' => array(
				'type' => 'select',
				'label' => __pl('posts_grid_custom_tax_field_label'),
				'default' => 'slug',
				'list' => array(
					'term_id' => __pl('term_id'),
					'slug' => __pl('slug'),
					'name' => __pl('name')
				)
			),
			'custom_tax_terms' => array(
				'type' => 'text',
				'label' => __pl('posts_grid_custom_tax_term_label'),
				'default' => '',
				'desc' =>__pl('posts_grid_custom_tax_term_desc')
			),
			'posts_count' => array(
				'type' => 'spinner',
				'label' => __pl('posts_slider_posts_count_label'),
				'default' => 3,
				'min' => 1,
				'max' => 100,
				'step' => 1
			),
			'order_by' => array(
				'type' => 'select',
				'label' => __pl('posts_slider_order_by'),
				'default' => 'date',
				'list' => array(
					'ID' => __pl('posts_slider_order_by_id'),
					'date' => __pl('posts_slider_order_by_date'),
					'author' => __pl('posts_slider_order_by_author'),
					'modified' => __pl('posts_slider_order_by_modified'),
					'rand' => __pl('posts_slider_order_by_random'),
					'comment_count' => __pl('posts_slider_order_by_comment_count'),
					'menu_order' => __pl('posts_slider_order_by_menu_order'),
				),
			),
			'sort_order' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_sort_order'),
				'default' => 'DESC',
				'list' => array(
					'ASC' => __pl('posts_grid_sort_order_ascending'),
					'DESC' => __pl('posts_grid_sort_order_descending')
				),
			),
			'title_tag' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_post_title_tag'),
				'default' => 'h2',
				'list' => array(
					'h1' => 'H1',
					'h2' => 'H2',
					'h3' => 'H3',
					'h4' => 'H4',
					'h5' => 'H5',
					'hide' => __pl('posts_grid_title_tag_none'),
				)
			),
			'show_content' => array(
				'type' => 'radio',
				'label' => __pl('posts_grid_show_content'),
				'default' => 'short',
				'list' => array(
					'short' => __pl('posts_grid_show_content_short'),
					'full' => __pl('posts_grid_show_content_full'),
					'excerpt' => __pl('posts_grid_show_content_excerpt'),
					'hide' => __pl('posts_grid_show_content_none'),
				),
			),
			'short_content_length' => array(
				'type' => 'slider',
				'label' => __pl('posts_grid_short_content_length'),
				'default' => 200,
				'min' => 0,
				'max' => 1000,
				'step' => 20,
				'req' => array(
					'show_content' => 'short'
				),
			),
			'image_size' => array(
				'type' => 'radio',
				'label' => __pl('obj_image_size_label'),
				'default' => 'thumbnail',
				'list' => array(
					'full' => __pl('full'),
					'large' => __pl('large'),
					'medium' => __pl('medium'),
					'thumbnail' => __pl('thumbnail'),
					'custom' => __pl('custom')
				),
				'req' => array(
					'!layout' => 'title_text'
				)
			),
			'custom_size' => array(
				'type' => 'text',
				'desc' => __pl('image_custom_size_label'),
				'req' => array(
					'image_size' => 'custom'
				),
			),
			'layout' => array(
				'type' => 'select',
				'label' => __pl('service_box_layout_label'),
				'default' => 'title_img_text_wrap',
				'list' => array(
					//'title_img_text' => __pl('posts_slider_layout_title_image_text'),
					'img_title_text' => __pl('posts_slider_layout_image_title_text'),
					//'title_img_inline' => __pl('posts_slider_layout_image_title_inline'),
					'title_img_text_wrap' => __pl('posts_slider_layout_image_title_text_wrap'),
					'title_text'=> __pl('posts_slider_layout_title_text')
				),
			),
			'img_position' => array(
				'type' => 'radio',
				'label' => __pl('posts_slider_image_position'),
				'default' => 'left',
				'list' => array(
					'left' => __pl('left'),
					'right' => __pl('right'),
				),
				'req' => array(
					'!layout' => 'title_text'
				)
			),
			'post_link' => array(
				'type' => 'select',
				'label' => __pl('image_link_label'),
				'default' => 'link_to_post',
				'list' => array(
					'link_to_post' => __pl('posts_slider_post_link'),
					'custom_link' => __pl('posts_slider_open_custom_links'),
					'no_link' => __pl('posts_slider_no_link'),
				),
			),
			'custom_links' => array(
				'type' => 'textarea',
				'label' => __pl('posts_slider_open_custom_links'),
				'default' => site_url(),
				'desc' => __pl('posts_slider_custom_links_description'),
				'req' => array(
					'post_link' => 'custom_link'
				),
			),
			'slideshow_speed' => array(
				'type' => 'radio',
				'label' => __pl('posts_slider_auto_rotate_label'),
				'default' => '15000',
				'list' => array(
					'3000' => '3',
					'5000' => '5',
					'10000' => '10',
					'15000' => '15',
					'25000' => '25',
					'disable' => __pl('disable'),
				),
			),
			'animation' => array(
				'type' => 'select',
				'label' => __pl('image_slider_animation_label'),
				'default' => 'fade',
				'list' => array(
					'horizontal' => __pl('image_slider_animation_slide'),
					'fade' => __pl('image_slider_animation_fade'),
				),
			),
			'smooth_height' => array(
				'type' => 'checkbox',
				'label' => __pl('image_slider_smooth_height_label'),
				'default' => 'true',
				'desc' => __pl('image_slider_smooth_height_desc'),
				'req' => array(
					'animation' => 'slide'
				)
			),
			'show_nav' => array(
				'type' => 'checkbox',
				'label' => __pl('image_slider_control_nav_label'),
				'default' => 'true',
			),
			'pause_on_hover' => array(
				'type' => 'checkbox',
				'label' => __pl('posts_slider_pause_on_hover_label'),
				'default' => 'true',
			),
		)
	)
);

// Pages
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_pages', array(
		'name' => __pl('pages'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_pages',
		'html' => '<div class="pagelayer-wp-pages-container">
			<div class="pagelayer-wp-pages-title"></div>
			<div class="pagelayer-wp-pages"></div>
		</div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_pages'),
				'desc' => __pl('wp_pages_description')
			),
			'sortby' => array(
				'type' => 'select',
				'label' => __pl('sort_by'),
				'default' => 'menu_order',
				'desc' => '',
				'list' => array(
					'post_title' => __pl('sort_by_page_title'),
					'menu_order' => __pl('sort_by_page_order'),
					'ID' => __pl('sort_by_page_id')
				),
			),
			'exclude' => array(
				'type' => 'text',
				'label' => __pl('exclude'),
				'default' => '',
				'desc' => __pl('wp_pages_exclude_pages')
			)
		)
	)
);

// Recent Posts
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_posts', array(
		'name' => __pl('Recent Posts'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_posts',
		'html' => '<div class="pagelayer-wp-posts-container">
			<div class="pagelayer-wp-posts-title"></div>
			<div class="pagelayer-wp-posts-section"></div>
		</div>',
		'params' => array(
			'title' => array(
					'type' => 'text',
					'label' => __pl('parameters_title'),
					'default' => __pl('wp_recent_posts'),
					'desc' => __pl('wp_recent_posts_description')
			),
			'number' => array(
					'type' => 'text',
					'label' => __pl('wp_recent_posts_number'),
					'default' => '5',
					'desc' => ''
			),
			'show_date' => array(
					'type' => 'checkbox',
					'label' => __pl('wp_recent_posts_display_date'),
					'default' => '',
					'desc' => ''
			)
		)
	)
);

// Calendar
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_calendar', array(
		'name' => __pl('calendar'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_calendar',
		'html' => '<div class="pagelayer-wp-calendar-container"></div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_calendar'),
				'desc' => __pl('wp_calendar_description')
			)
		)
	)
);

// Recent Comments
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_comments', array(
		'name' => __pl('Recent Comments'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_comments',
		'html' => '<div class="pagelayer-recent-comments-widget">
			<h5 class="pagelayer-recent-comments-title">Recent Comments</h5>
			<ul class="pagelayer-recent-comments-ul"></ul>
		</div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_recent_comments'),
				'desc' => __pl('wp_recent_comments_description')
			),
			'number' => array(
				'type' => 'text',
				'label' => __pl('wp_recent_comments_number'),
				'default' => '5',
				'desc' => ''
			)
		)
	)
);

// Categories
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_categories', array(
		'name' => __pl('categories'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_categories',
		'html' => '<div class="pagelayer-wp-categories-container">
			<div class="pagelayer-wp-categories-title"></div>
			<div class="pagelayer-wp-categories-section"></div>
		</div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_categories'),
				'desc' => __pl('wp_categories_description')
			),
			'dropdown' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_display_as_drop_down'),
				'default' => '',
				'desc' => ''
			),
			'count' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_show_post_counts'),
				'default' => '',
				'desc' => ''
			),
			'hierarchy' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_categories_show_hierarchy'),
				'default' => '',
				'desc' => ''
			)
		)
	)
);

// Archives
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_archives', array(
		'name' => __pl('archives'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_archives',
		'html' => '<div class="pagelayer-wp-archives-div">
			<h5 class="pagelayer-wp-archives-title">Archives</h5>
			<div class="pagelayer-wp-archives-option"></div>
		</div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_archives'),
				'desc' => __pl('wp_archives_description')
			),
			'dropdown' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_display_as_drop_down'),
				'default' => '',
				'desc' => ''
			),
			'count' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_show_post_counts'),
				'default' => '',
				'desc' => ''
			)
		)
	)
);

// Tag Cloud
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_tags', array(
		'name' => __pl('Tag Cloud'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_tags',
		'html' => '<div class="pagelayer-wp-tags-div">
			<h5 class="pagelayer-wp-tags-title">Tags</h5>
			<div class="pagelayer-wp-tags-option"></div>
		</div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_tags'),
				'desc' => __pl('wp_tag_cloud_description')
			),
			'taxonomy' => array(
				'type' => 'select',
				'label' => __pl('wp_tag_cloud_taxonomy'),
				'default' => 'post_tag',
				'desc' => '',
				'list' => array(
					'post_tag' => __pl('wp_tags'),
					'category' => __pl('wp_tag_cloud_categories'),
				)
			)
		)
	)
);

// Search
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_search', array(
		'name' => __pl('search'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_search',
		'html' => '<div class="pagelayer-wp-search-div">
			<h5 class="pagelayer-wp-search-title">Search</h5>
			<div class="pagelayer-wp-search-option"></div>
		</div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_rsssearch'),
				'desc' => __pl('wp_rsssearch_description')
			)
		)
	)
);

// RSS
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_rss', array(
		'name' => __pl('rss'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_rss',
		'html' => '<div class="pagelayer-wp-rss-div">
			<div class="pagelayer-wp-rss-option"></div>
		</div>',
		'params' => array(
			'url' => array(
				'type' => 'text',
				'label' => __pl('wp_rssurl'),
				'default' => 'http://www.getpagelayer.com/feed/',
				'desc' => __pl('wp_rssurl_description')
			),
			'title' => array(
				'type' => 'text',
				'label' => __pl('wp_rssfeed_title'),
				'default' => '',
				'desc' => __pl('wp_rssfeed_title_description')
			),
			'items' => array(
				'type' => 'select',
				'label' => __pl('wp_rssquantity'),
				'default' => 9,
				'desc' => __pl('wp_rssquantity_description'),
				'list' => array(
					1 => 1,
					2 => 2,
					3 => 3,
					4 => 4,
					5 => 5,
					6 => 6,
					7 => 7,
					8 => 8,
					9 => 9,
					10 => 10
				),
			),
			'show_summary' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_rssdisplay_content'),
				'default' => '',
				'desc' => ''
			),
			'show_author' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_rssdisplay_author'),
				'default' => '',
				'desc' => ''
			),
			'show_date' => array(
				'type' => 'checkbox',
				'label' => __pl('wp_rssdisplay_date'),
				'default' => '',
				'desc' => ''
			)
		)
	)
);

// Meta
pagelayer_add_shortcode(PAGELAYER_SC_PREFIX.'_wp_meta', array(
		'name' => __pl('meta'),
		'group' => 'wordpress',
		'func' => 'pagelayer_sc_wp_meta',
		'html' => '<div class="pagelayer-wp-meta-div">
			<div class="pagelayer-wp-meta-option"></div>
		</div>',
		'params' => array(
			'title' => array(
				'type' => 'text',
				'label' => __pl('parameters_title'),
				'default' => __pl('wp_meta'),
				'desc' => __pl('wp_meta_description')
			)
		)
	)
);